package com.farata.messaging.qos
{	
	import mx.messaging.Consumer;
	import mx.messaging.events.MessageEvent;
	
	public class ServerHeartbeatConsumer extends Consumer
	{		
		public function ServerHeartbeatConsumer()
		{
		}	
		public function startHeartbeat(destination:String="serverbeat") : void {	
			if (connected)
				stopHeartbeat();
			this.destination = destination;
			subscribe();
			addEventListener(MessageEvent.MESSAGE, onHeartbeat);
		}
		public function stopHeartbeat() : void {	
			unsubscribe(false);
		}	
		private function onHeartbeat( event:MessageEvent): void {
			serverTimeDelay = Math.min( serverTimeDelay, new Date().valueOf() - event.message.timestamp);
			currentLatency = new Date().valueOf() - event.message.timestamp - serverTimeDelay;
			maxLatency = Math.max( maxLatency, currentLatency );
		}

		[Bindable] public var serverTimeDelay:Number = Number.MAX_VALUE;  
		[Bindable] public var currentLatency:Number = 0;  
		[Bindable] public var maxLatency:Number = 0;  
	}
}