package 
{
	import flash.display.Sprite;
	import flash.text.TextField;
	
	import mx.core.UIComponent;
	
	public class MessageBar extends UIComponent {
			
		public var spacing:int=2;
		public var radius:int= 16;
		public var maxPosition:int=-1;


		public function appendMessageBlock(lastPosition:int):void {
			if (lastPosition > maxPosition+1) {
				for (var i:int=maxPosition+1; i<lastPosition; i++) {
					addMessage(i, i);
				}
			}
			addMessage(lastPosition, lastPosition);
		}
		
		public function appendMessage(id:int, color:Number=0xFFCC00):void {
			if (id!=-1)
				addMessage(maxPosition + 1, id, color);
		}
		public function addMessage(position:int, id:int, color:Number=0xFFCC00):void {
			var prevMaxPosition:int = maxPosition;				
			maxPosition = Math.max(position, maxPosition);
			if (maxPosition>prevMaxPosition) invalidateSize();
			var sprite:Sprite = new Sprite();
			sprite.graphics.beginFill(color);
			this.graphics.endFill();
			var offsetX:int = (radius*2 + spacing) * (position) + radius;
			var offsetY:int = radius; 
			sprite.graphics.drawCircle(offsetX, offsetY, radius);           
			var label:TextField = new TextField();
			label.width = 20;
			label.text = "" + id;
			label.x = offsetX - 6;
			label.y = offsetY - 8;
			
			sprite.addChild(label);
			
			addChild(sprite);
		}

		public function clean():void {
			while (maxPosition>=0) {
				removeChildAt(maxPosition);
				maxPosition--;	
			}
		}

		override protected function measure():void {
	        super.measure();
			measuredMinWidth = measuredWidth =  (radius*2 + spacing) * (maxPosition) +  getStyle("paddingLeft") + getStyle("paddingRight"); 
			measuredMinHeight = measuredHeight = radius*2 +  getStyle("paddingTop") + getStyle("paddingBottom"); 
		}

	}
}