package com.farata.messaging.adapters;

import org.apache.log4j.Logger;

import com.farata.messaging.messages.ClientHeartbeatMessage;
import com.farata.messaging.messages.ServerHeartbeatMessage;

import flex.messaging.messages.Message;
import flex.messaging.services.MessageService;
import flex.messaging.services.messaging.adapters.MessagingAdapter;

public class HeartbeatAdapter extends MessagingAdapter
{
    public Object invoke(Message message)
    {
    	if ( message instanceof ServerHeartbeatMessage){
    	    MessageService msgService = (MessageService)getDestination().getService();
            msgService.pushMessageToClients(message, true);
            // This would be needed only if each server would not serve it's own clients
            //msgService.sendPushMessageFromPeer(message, true);
    	}
    	 else if ( message instanceof ClientHeartbeatMessage ) {
     		ClientHeartbeatMessage chm = (ClientHeartbeatMessage) message;
    	   	logger.info("Client "  + message.getClientId() + " heartbeat");
     		//flex.messaging.FlexContext.getHttpRequest().getSession().invalidate();

     		// FlexSession, when did I receive last
     		// Thread - no more in 5 seconds? logoff the client
     		//if ((chm.received!=null) && (chm.received.length>0)) 
     		//System.out.println("----- QoS adapter: removing received by client:");
    	 }	
     		
        return null;
    }
    static Logger logger;
	static	{
	        logger = Logger.getLogger(HeartbeatAdapter.class);
	}

}
