package com.farata.messaging.endpoints;

import org.apache.log4j.Logger;
import com.farata.messaging.messages.ReliableClientMessage;
import flex.messaging.endpoints.RTMPEndpoint;
import flex.messaging.messages.AcknowledgeMessage;
import flex.messaging.messages.Message;

public class AcknowledgingRTMPEndpoint extends RTMPEndpoint {
	private final String LAST_SERVED_NUMBER="lastServedNumber";
	private final String SEQUENCE_NUMBER="seqNo";

	public Message serviceMessage(Message message) {
		Message m = super.serviceMessage(message);
		
		if (message instanceof ReliableClientMessage) {
			int sequenceNumber = (Integer)message.getHeader(SEQUENCE_NUMBER) ;
			int lastServedNumber = sequenceNumber; 
			String duplicate = (String)message.getHeader("duplicate");
			if (logger.isDebugEnabled()) logger.debug(
				"Received message "+ sequenceNumber + ((duplicate!=null)?" (duplicate)":"")
			);
			AcknowledgeMessage acknowledgeMessage = new AcknowledgeMessage();
			acknowledgeMessage.setClientId(message.getClientId());
			acknowledgeMessage.setCorrelationId(message.getMessageId());
			acknowledgeMessage.setHeader(LAST_SERVED_NUMBER, (Integer)lastServedNumber);
			m = acknowledgeMessage;
		}
		
		return m;
	}
	static Logger logger;
	static {
	        logger = Logger.getLogger(AcknowledgingRTMPEndpoint.class);
	}
}
