/**
 * The QoSRTMPEndpoint class adds QoS info to the FDS class RTMPEndpoint, which is used to connect to an
 * RTMP channel (real-time messaging, server push)
 */
package com.farata.messaging.endpoints;

import org.apache.log4j.Logger; 

import com.farata.messaging.messages.ServerHeartbeatMessage;

import flex.messaging.config.ConfigMap;
import flex.messaging.endpoints.RTMPEndpoint;
import flex.messaging.util.UUIDUtils;

public class HeartbeatRTMPEndpoint extends RTMPEndpoint {

    public static int SERVER_HEARTBEAT = 2000;

	
	public void initialize(String id, ConfigMap properties){
		super.initialize(id, properties);
		heartbeatSender = new HeartbeatSender();
		Thread heartbeatSenderThread = 
            new Thread(heartbeatSender, "SessionManager");
        heartbeatSenderThread.setDaemon(true);
        heartbeatSenderThread.start();
 	}

	protected static HeartbeatSender heartbeatSender = null;
	public class HeartbeatSender implements Runnable {
	     public void run() {
	    	 while (true) {
	        	try {
	        		Thread.sleep(SERVER_HEARTBEAT);
	        		/*
	        		HeartbeatMessage message = new HeartbeatMessage();
	        		message.setMessageId(UUIDUtils.createUUID(false));
	        		message.setDestination("serverbeat");
	        		message.setBody("Heartbeat to users" );
	        		message.setTimestamp( System.currentTimeMillis());
		   			serviceMessage(message);
		   			*/			    
	        	} catch (InterruptedException ex){
	        		if (logger.isInfoEnabled()) logger.info(".......in HeartbeatSender......Interrupted");  
	        	}
	        }
	    }
	}

    static Logger logger;
	static	{
	        logger = Logger.getLogger(HeartbeatRTMPEndpoint.class);
	}
}