package com.farata.test;

import java.util.ArrayList;

import com.farata.messaging.messages.ReliableServerMessage;

import flex.messaging.MessageBroker;

public class ServerMessagingTest {

	private static MessageBroker mb;

	private void send(ReliableServerMessage message) {
		if (mb == null) {
			mb = MessageBroker.getMessageBroker(null);
		}
		mb.routeMessageToService(message, null);
	}

	public void testDeliveryFailure(String clientId, int start, int messageCount) {

		ReliableServerMessage message;
		for (int i= 0; i < messageCount; i++) {
			message = new ReliableServerMessage("Server message #"  + (i+start));
			message.setHeader("tm", "true");
			message.setClientId(clientId);
			message.setDestination("serverDeliveryTest");
			message.setHeader("seqNo", "" + (i+start));
			send(message);
		}
	}

	public void testSequenceFailure(String clientId, int start, int messageCount) {

		ReliableServerMessage message;
		ArrayList<ReliableServerMessage> messages = new ArrayList<ReliableServerMessage>();
		for (int i= 0; i < messageCount; i++) {
			message = new ReliableServerMessage("Server message #"  + (i+start));
			message.setClientId(clientId);
			message.setDestination("serverSequenceTest");
			message.setHeader("seqNo", "" + (i+start));
			messages.add(message);
		}

		for (long i = 0; i < messageCount; i++) {
			int randomPick = (int )Math.min(
				Math.round(Math.random() * messages.size()),
				messages.size()-1
			);
			message = messages.remove(randomPick);
			send(message);
		}
	}
	public void testAll(String clientId, int start, int messageCount) {

		ReliableServerMessage message;
		ArrayList<ReliableServerMessage> messages = new ArrayList<ReliableServerMessage>();
		for (int i= 0; i < messageCount; i++) {
			message = new ReliableServerMessage("Server message #"  + (i+start));
			message.setHeader("tm", "true");
			message.setClientId(clientId);
			message.setDestination("reliableMessagingTest");
			message.setHeader("seqNo", "" + (i+start));
			messages.add(message);
		}

		for (long i = 0; i < messageCount; i++) {
			int randomPick = (int )Math.min(
				Math.round(Math.random() * messages.size()),
				messages.size()-1
			);
			message = messages.remove(randomPick);
			send(message);
		}
	}	
}
